package nl.amis;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.faces.event.ActionEvent;

import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.view.faces.component.core.data.CoreTree;

import oracle.jbo.RowSetIterator;
import oracle.jbo.uicli.binding.JUCtrlHierNodeBinding;
import oracle.jbo.uicli.binding.JUIteratorBinding;

public class TreeBean {
    private CoreTree tree;
    private List focusRowKey;
    
    public TreeBean() {
    }

    public void setTree(CoreTree tree) {
        this.tree = tree;
    }

    public CoreTree getTree() {
        return tree;
    }

    public void setFocusRowKey(List focusRowKey) {
        this.focusRowKey = focusRowKey;
    }

    public List getFocusRowKey() {
        return focusRowKey;
    }

    public void expandCurrent(ActionEvent event) {
        List currentFocusRowKey = new ArrayList();
        currentFocusRowKey.addAll(getFocusRowKey());
        int currentLevel = currentFocusRowKey.size();
        getTree().getTreeState().getKeySet().add(currentFocusRowKey);
        expandNode(currentLevel, currentFocusRowKey, 4);
    }


    private void expandNode(int currentLevel, List currentFocusRowKey, 
                            int numberOfLevels) {
        if (numberOfLevels > 0) {
            currentLevel++;
            for (int i = 0; i < 4; i++) {
                currentFocusRowKey.add(Integer.toString(i));
                System.out.println("add " + currentFocusRowKey);
                getTree().getTreeState().getKeySet().add(currentFocusRowKey);
                expandNode(currentLevel, currentFocusRowKey, --numberOfLevels);
                currentFocusRowKey.remove(currentLevel - 1);
            } //for
            currentLevel--;
        }
    }

    public void collapseCurrent(ActionEvent event) {
        List currentFocusRowKey = new ArrayList();
        currentFocusRowKey.addAll(getFocusRowKey());
        getTree().getTreeState().getKeySet().remove(currentFocusRowKey);
        Iterator keys = getTree().getTreeState().getKeySet().iterator();
        while (keys.hasNext()) {
            List rowKey = (List)keys.next();
            if (listStartsWith(rowKey, currentFocusRowKey)) {
               getTree().getTreeState().getKeySet().remove(rowKey);
            }
        }
    }
    
    private boolean listStartsWith(List check, List against) {
        if (check.size()> against.size()) {
          for (int i = 0;i < Math.min(check.size(),against.size());i++ ) {
            if (!((String)check.get(i)).equalsIgnoreCase((String)against.get(i)))
              return false; 
          }// for
          return true;
        }// if        
        return false;
    }

}
